STATIC void bls_exit0(int c)
{
	exit(c);
}

STATIC void *bls_malloc(int n)
{
	return malloc(n);
}

STATIC void bls_free(int n, void *p)
{
	if (p != 0)
		free(p);
}

STATIC clock_t bls_clock()
{
	return clock() / (CLOCKS_PER_SEC / 1000);
}

STATIC void bls_err(const char *s)
{
	fprintf(stderr, "%s\n", s);
	exit(1);
}
