#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <time.h>
#include <math.h>
#include <stdint.h>
#include <SDL2/SDL.h>
#define STATIC
typedef clock_t bls_clock_t;
#include "bls_sdl2.h"
#include "bls.c"
#include "bls0_sdl2.c"
#include "bls0_stdc.c"

int main()
{
	bls_init();
	bls_Window *w = bls_openWin(512, 384, "mandel", 1);

	int x, y;
	for (y = 0; y < 384; y++) {
		for (x = 0; x < 512; x++) {
			int sn = 0, sx, sy, n, c;
			int64_t cx, cy, zx, zy, xx, yy;
			for (sx = 0; sx < 4; sx++) {
				cx = (x*4+sx)*56+4673536;
				for (sy = 0; sy < 4; sy++) {
					cy = (y*4+sy)*(-56)-124928;
					zx=cx; zy=cy;
					for (n=1; n<447;n++) {
						xx=(zx*zx)>>24;
						yy=(zy*zy)>>24;
						if (xx+yy>0x4000000) break;
						zy=(zy*zx)>>23;
						zx=xx+cx-yy;
						zy+=cy;
					}
					sn+=n;
				}
			}
			n=sn>>4;
			c=bls_xrgb(n, 0, 0);
			if (n>=256) {
				c=bls_xrgb(0, 0, 0);
				if (n < 447)
					c = bls_xrgb(255, n-255, 0);
			}
			bls_setPix(w, x, y, c);
		}
		bls_leapFlushAll(w, 128);
	}
	bls_wait(-1);
	return 0;
}
